<script>

import { onMount } from 'svelte';

import Picker from './Picker.svelte'

export let label          = '';
export let vehicles       = [];
export let currentVehicle = 0;

function onChangePrimaryColor(e) {
	const {r, g, b, a, hex} = e.detail;
	window.parent.postMessage(JSON.stringify({action: 'set_primary_color', r, g, b}), '*');
}

function onChangeSecondaryColor(e) {
	const {r, g, b, a, hex} = e.detail;
	window.parent.postMessage(JSON.stringify({action: 'set_secondary_color', r, g, b}), '*');
}

function onMessage(msg) {

	switch(msg.action) {

		case 'load' : {

			label    = msg.data.label;
			vehicles = msg.data.vehicles;

			break;
		}

		default: break;
	}

}

function onCancel(e) {
	window.parent.postMessage(JSON.stringify({action: 'cancel'}), '*');
} 

function onSubmit(e) {
	window.parent.postMessage(JSON.stringify({action: 'submit', vehicle: vehicles[currentVehicle]}), '*');
} 

function prevVehicle(e) {

	if(currentVehicle - 1 < 0)
		currentVehicle = vehicles.length - 1;
	else
		currentVehicle--;

	window.parent.postMessage(JSON.stringify({action: 'set_vehicle', vehicle: vehicles[currentVehicle]}, '*'));

}

function nextVehicle(e) {

	if(currentVehicle + 1 > vehicles.length - 1)
		currentVehicle = 0;
	else
		currentVehicle++;

	window.parent.postMessage(JSON.stringify({action: 'set_vehicle', vehicle: vehicles[currentVehicle]}, '*'));

}

onMount(() => {
	window.parent.postMessage(JSON.stringify({action: 'component_mounted'}), '*');
});

window.addEventListener('message', e => onMessage(JSON.parse(e.data)));

</script>

<style>

	.cardealer-ui {
		height: 100%;
	}

	.frame-left {
		width: 240px;
		height: calc(100% - 20px);
		background-color: #272525;
		display: flex;
		flex-direction: column;
		align-items: center;
		padding: 10px;
		color: #FFF;
	}

	.frame-left > * {
		margin: 20px;
		padding: 15px;
	}

	.category {
		text-transform: uppercase;
	}

	.vehicle-selector {
		display: flex;
    flex-direction: row;
    justify-content: space-between;
		width: 100%;
		text-transform: uppercase;
		user-select: none;
	}

	.cardealer-ui button {
    width: 100%;
    margin-top: 10px;
    margin-bottom: 10px;
    background-color: #000;
    color: #FFF;
    border: 1px solid #555;
	}

	.cardealer-buy-price {
		color:rgb(0, 128, 0);
	}

	.color-picker {
		display: flex;
		flex-direction: column;
		align-items: center;
		justify-content: center;
	}

	.color-picker-label {
		padding: 10px;
		text-align: center;
	}

	.slider:hover {
		color: red;
	}

</style>

<div class="cardealer-ui">
	<div class="frame-left">
		<div class="category">{label}</div>
		<div class="vehicle-selector">
			<div class="slider" on:mousedown={prevVehicle}>&lt;</div>
			<div>{vehicles && vehicles[currentVehicle] ? vehicles[currentVehicle].gxt : ''}</div>
			<div class="slider" on:mousedown={nextVehicle}>&gt;</div>
		</div>
		<div class="color-picker">
			<div class="color-picker-label">Couleur primaire</div>
			<Picker on:colorchange={onChangePrimaryColor} startColor={'#000000'}/>
		</div>
		<div>
			<div class="color-picker-label">Couleur secondaire</div>
			<Picker on:colorchange={onChangeSecondaryColor} startColor={'#000000'}/>
		</div>
		<button on:mouseup={onCancel}>Annuler</button>
		<button on:mousedown={onSubmit}>Acheter - <span class="cardealer-buy-price">${vehicles && vehicles[currentVehicle] ? vehicles[currentVehicle].price : ''}</span></button>
	</div>
</div>
